package animation;

public interface CodeLine {

    public ControlFlow runForward( Memory m );
    public ControlFlow runBackward( Memory m );
    
    public static final CodeLine DEFAULT_STEP_INTO_STACK = new CodeLine() {

        @Override
        public ControlFlow runForward(Memory m) {
            m.addFrame();
            return new ControlFlow( ControlFlow.STEP_INTO_STACK );
        }

        @Override
        public ControlFlow runBackward(Memory m) {
            m.addFrame();
            return new ControlFlow( ControlFlow.STEP_INTO );
        }
    };
}
