package animation;

import java.util.Stack;

public class Memory {

    private StackFrame global;
    private Stack< StackFrame > stack;
    
    public Memory()
    {
        stack = new Stack<StackFrame>();
        global = new StackFrame();
    }
    
    public void addFrame()
    {
        stack.push( new StackFrame() );
    }
    
    public void removeFrame()
    {
        stack.pop();
    }
    
    public <T> void declare( String name, T value, boolean global )
    {
        if( global )
            this.global.declare( name, value );
        else
            stack.peek().declare( name, value );
    }
    
    public <T> void write( String name, T value, boolean global )
    {
        if( global )
            this.global.set( name, value );
        else
            stack.peek().set( name, value );
    }
    
    public <T> T read( String name, boolean global )
    {
        if( global )
            return this.global.get( name );
        else
            return stack.peek().get( name );
    }
    
    public void undeclare( String name, boolean global )
    {
        if( global )
            this.global.undeclare( name );
        else
            stack.peek().undeclare( name );
    }
}
