package animation;

import java.util.HashMap;

public class StackFrame {

    private HashMap< String, Object > data;
    
    public StackFrame()
    {
        data = new HashMap< String, Object >();
    }
    
    public <T> void declare( String name, T value )
    {
        data.put( name, (Object)value );
    }
    
    public <T> void set( String name, T value )
    {
        data.put( name, (Object)value );
    }
    
    public void undeclare( String name )
    {
        data.remove( name );
    }
    
    public boolean isDefined( String name )
    {
        return data.containsKey( name );
    }
    
    @SuppressWarnings("unchecked")
    public <T> T get( String name )
    {
        return (T)data.get( name );
    }
}
